   --  襭    譥 
   -- *********************************************************
   import Tree
   -----------------------------------------------------------
   -- 㭪 頥 㬬 祭, ࠭  設
   -- ᫮ ୮ ॢ ᪠ tree
   -----------------------------------------
   summa:: BTree -> Int
   summa tree | tree==Nil = 0
              | True      = root tree + summa (left tree)
                                      + summa (right tree)
   -----------------------------------------------------------
   -- 㭪 頥 㬬 祭, ࠭  設
   -- ᫮ ୮ ॢ ᪠ tree
   -- ( ᯮ짮 ᮯ⠢  ࠧ殬)
   ----------------------------------------------
   summa':: BTree -> Int
   summa' Nil = 0
   summa' (Node x l r) = x + summa' l + summa' r
   ----------------------------------------------------------
   -- 㭪,   ᫮ ୮ ॢ ᪠ 㢥-
   -- 稢  1 祭, 室騥  設
   -------------------------------------------------
   tInc:: BTree -> BTree
   tInc tree | tree==Nil = Nil
             | True      = Node (1 + root tree) 
                                (tInc $ left tree) 
                                (tInc $ right tree)
   ----------------------------------------------------------
   -- 㭪,   ᫮ ୮ ॢ ᪠ 㢥-
   -- 稢  1 祭, 室騥  設
   -- ( ᯮ짮 ᮯ⠢  ࠧ殬)
   ----------------------------------------------
   tInc':: BTree -> BTree
   tInc' Nil          = Nil
   tInc' (Node x l r) = Node (1+x) (tInc' l) (tInc' r)
   -----------------------------------------------------
   -- 㭪,  "쥢 ਭ" ᫮
   -- ୮ ॢ ᪠, .. ࠧ  ᠬ
   -- ࠢ  ᠬ  ﬨ ॢ
   ---------------------------------------
   width:: BTree -> Int
   width tree = rightList tree - leftList tree
   -----------------------------------------------------
   -- 㭪,  "ਭ" ᫮ ୮
   -- ॢ ᪠, .. ࠧ 讣  -
   -- 襣  ॢ
   ------------------------
   widthTree:: BTree -> Int
   widthTree tree = ud tree - ud' tree
   -------------------------------------------------
   -- 㭪,  ᯨ᮪ 쥢 ୮
   -- ॢ ᪠
   -----------------------
   leaves:: BTree -> [Int]                          
   leaves Nil = []
   leaves (Node x l r) | l==Nil && r==Nil = [x]
                       | True             = leaves l ++ leaves r
   --------------------------------------------------------------
   -- 㭪, ᮥ ୮ ॢ ᪠ tree1 
   --   x 㣮 ୮ ॢ ᪠ tree
   -- (祭 ॢ 㦥    ॢ ᪠!)
   --------------------------------------------------------
   mountTree:: BTree -> BTree -> Int -> BTree
   mountTree Nil          tree1 a = nil
   mountTree (Node x l r) tree1 a
                      | a==x = tree1
                      | a<x  = node x (mountTree l tree1 a) r
                      | True = node x l (mountTree r tree1 a)
   --------------------------------------------------------------
   -- 㭪, ᮥ ୮ ॢ ᪠ tree1 
   --   x 㣮 ୮ ॢ ᪠ tree
   -- (祭 ॢ 㦥    ॢ ᪠!)
   --------------------------------------------------------
   mount':: BTree -> BTree -> [Int] -> BTree
   mount' tree tree1 [] = tree
   mount' tree tree1 (x:lst) = mount' (mountTree tree tree1 x) 
                                      tree1
                                      lst
   -- ***********************************
   -- 㤠 ⮢ ਬ:
   ------------------------------
   test = testSum && testTInc
   ----------------------------------------------------------
   testSum =   summa Nil                                ==  0
            && summa (Node 10 Nil Nil)                  == 10
            && summa (Node 3 (Node 2 Nil Nil) (Node 4 Nil Nil))
                                                        ==  9
            && summa (Node 4 (Node 2 Nil (Node 3 Nil Nil))
                            (Node 6 (Node 5 Nil Nil)
                                    (Node 7 Nil Nil)))  == 27
            && summa (Node 10 
                          (Node 6 (Node (-27) Nil Nil)
                                  (Node 7 Nil (Node 8 Nil Nil)))
                          (Node 15 (Node 12 Nil Nil)
                                   (Node 18 (Node 17 Nil Nil)
                                            Nil)))      == 66
   ----------------------------------------------------------
   testTInc =   tInc (Node 3 Nil Nil)
                       == Node 4 Nil Nil

             && tInc (Node 3 (Node 5 Nil Nil)
                             (Node 4 Nil Nil))
                       == Node 4 (Node 6 Nil Nil) (Node 5 Nil Nil)

             && tInc (Node 4 (Node 2 Nil (Node 3 Nil Nil))
                             (Node 6 (Node 5 Nil Nil)
                                     (Node 7 Nil Nil)))
                       == Node 5 (Node 3 Nil (Node 4 Nil Nil))
                                 (Node 7 (Node 6 Nil Nil)
                                         (Node 8 Nil Nil))
   -------------------------------------------------------
   tree = node 10 (node 6 (list 3) (node 7 nil (list 8)))
                  (node 15 (list 12) 
                           (node 18 (list 17) nil))

   tree1 = node 10 (node 6 (list (-27)) (node 7 nil (list 8))) 
                   (node 15 (list 12) 
                            (node 18 (list 17) nil))

   tree2 = node (-1) (list (-1)) (list (-1))
   -----------------------------------------
   test1 = leaves tree; test2 = leaves tree1
   -----------------------------------------
   test3 = outTree tree;  test4 = width tree
   test5 = outTree tree1; test6 = width tree1
   ------------------------------------------
   test7 = do
             outTree tree
             putStr ("\n"++"Rezult: "++show (widthTree tree)++"\n")
   ----------------------------------------------------------------
   test8 = outTree tree1; test102 = widthTree tree1
   ------------------------------------------------
   test9 = widthTree (list 5)
   --------------------------------------------------------------
   test10 = outTree (mountTree (mountTree tree tree2 8) tree2 17)
   test11 = outTree (mount' tree tree2 (leaves tree))
